var E = require("events").EventEmitter;
var os = require("os").platform();

var methods = require(`./${os}.js`);

class Installer extends EventEmitter {
  constructor(){
    super();
  }

  start(){
    return methods.start().catch(() => this.install())
  }

  install(){
    this.emit('install', () => {
      return methods.install((evt) => {
        this.emit('progress', evt);
      }).then(() => methods.start()).catch(e => this.emit('error',e));
    })
  }
}
